"use strict";
const vue = require("vue");
const config = require("./chunks/config.cjs");
const vueTsx = require("./chunks/vue-tsx.cjs");
const props = {
  title: {
    type: String,
    default: ""
  },
  // 展示在工具栏的内容，通常是个图标
  trigger: {
    type: [String, Object]
  },
  onClick: {
    type: Function
  },
  /**
   * ==没有意义，仅用于规避克隆组件自动嵌入insert方法时，传入的是该组件而产生的waring
   */
  insert: {
    type: Function
  },
  language: {
    type: String
  },
  theme: {
    type: String
  }
  /**
   * ==结束
   */
};
const NormalToolbar = /* @__PURE__ */ vue.defineComponent({
  name: "NormalToolbar",
  props,
  emits: ["onClick"],
  setup(props2, ctx) {
    return () => {
      const Trigger = vueTsx.getSlot({
        props: props2,
        ctx
      }, "trigger");
      return vue.createVNode("div", {
        "class": `${config.prefix}-toolbar-item`,
        "title": props2.title,
        "onClick": (e) => {
          if (props2.onClick instanceof Function) {
            props2.onClick(e);
          } else {
            ctx.emit("onClick", e);
          }
        }
      }, [Trigger]);
    };
  }
});
NormalToolbar.install = (app) => {
  app.component(NormalToolbar.name, NormalToolbar);
  return app;
};
module.exports = NormalToolbar;
